#!/usr/bin/env python
# David D Lowe (c) 2008
# licensed under GPLv2
""" DEPRECATED!
This used to be the old managepigments.py module, for future reference only
managepigments.py is a module for Epidermis
it can: install and uninstall pigments, as well as read from installed pigments
it contains custom Exception classes"""
##
##from __future__ import division
###import gtkexcepthook
##import pygtk
##pygtk.require("2.0")
##import threading, gtk, socket
##import subprocess,os,sys,urlparse,urllib,gobject,httplib,xml, xml.dom
##from glob import glob
##import getopt
##import handy
##import shutil
##
##PUBLIC_PIGMENT_DIR = "/usr/share/epidermis/pigments/"
##
###---(Un)installation:---#000000#FFFFFF------------------------------------------
##
##def manage_pigments(application, installDict, removeDict, myDataHome):
##    """manage_pigments installs and uninstalls pigments! It also handles the GUI side of things
##    
##    application: the EpidermisApp object that's being run, usually self
##    installDict: a dictionary of the pigments to install, example:
##        {"skin":[],"wallpaper":["wallpigment1"],"metacity":[],"gtk":["gtkpak1","gtkpak2"], \
##        "icons":[],"gnomeSplash":[],"cursors":[],"grub":[],"gdm":[],"usplash":[]}
##    removeDict: a dictionary of the pigments to uninstall, in the same format as installDict"""
##    
##    application.runningManagePigments += 1
##    if application.runningManagePigments > 1:
##        raise()
##    
##    
##    def cancel_callback(widget):
##        """cancel_callback for the cancel button on the download window"""
##        app.cancel = True
##        gobject.idle_add(lambda:fetchWin.hide())
##        #gobject.idle_add(lambda:self.switch_to_toggled(self.tgInstalled))
##        #gobject.idle_add(lambda:self.tgInstalled.set_active(True))
##        
##        
##    def fetchWin_delete_callback(widget, event):
##        """the delete_callback for the download window, calls the cancel_callback, 
##        disallows closing"""
##        cancel_callback(cancelButton)
##        return True
##    
##    # still under manage_pigments
##    
##    app = application
##    # this next line reloads the glade file from fresh
##    wTree = gtk.glade.XML(app.wTreeFileName)
##    
##    # set up window
##    fetchWin = wTree.get_widget("winOperations")
##    fetchWin.set_destroy_with_parent(True)
##    fetchWin.set_title("Installing and uninstalling pigments")
##    progressbar = wTree.get_widget("progressbarOperations")
##    cancelButton = wTree.get_widget("butOperationsCancel")
##    progressbar.set_fraction(0)
##    fetchWin.connect("delete-event", fetchWin_delete_callback)
##    app.cancel = False
##    cancelButton.connect("clicked", cancel_callback)
##    
##    # start thread and show window
##    thr = ManagePigmentsThread(installDict,removeDict,app,progressbar,wTree, fetchWin, myDataHome)
##    fetchWin.show_all()
##    thr.start()
##
##class ManagePigmentsThread(threading.Thread):
##    """ManagePigmentsThread installs and uninstalls pigments"""
##    
##    def __init__(self,installDict,removeDict,app,progressbar, wTree, fetchWin, myDataHome):
##        """installDict: a dictionary of the pigments to install, example:
##            {"skin":[],"wallpaper":["wallpigment1"],"metacity":[],"gtk":["gtkpak1","gtkpak2"], \
##            "icons":[],"gnomeSplash":[],"cursors":[],"grub":[],"gdm":[],"usplash":[]}
##        removeDict: a dictionary of the pigments to uninstall, similar to installDict in format
##        app: the EpidermisApp application object
##        progressbar: the progressbar where progress should be displayed
##        wTree: the wTree from which fetchWin was referenced
##        fetchWin: the window where progress should be displayed"""
##        self.installDict = installDict
##        self.removeDict = removeDict
##        self.app = app
##        self.progressbar = progressbar
##        self.wTree = wTree
##        self.fetchWin = fetchWin
##        self.myDataHome = myDataHome
##        self.urls = []
##        self.operationsSummary = self.wTree.get_widget("lblOperationsSummary")
##        self.operationsInformation = self.wTree.get_widget("lblOperationsInformation")
##        threading.Thread.__init__(self)
##        
##    def run(self):
##
##        
##        # count number of pigments to install, if more than one, call
##        # download_pigments and install_pigments
##        npti = 0
##        for ii in self.installDict:
##            npti += len(self.installDict[ii])
##        if npti > 0:
##            self.download_pigments()
##            self.install_pigments()
##        
##        
##        #count number of pigments to uninstall, if more than one, call remove_pigments
##        nptu = 0
##        for ii in self.removeDict:
##            nptu += len(self.removeDict[ii])
##        if nptu > 0:
##            #print "removing"
##            self.remove_pigments()
##        
##        # hide window
##        gobject.idle_add(lambda: self.fetchWin.hide())
##        
##        # refresh app's main view:
##        self.app.find_and_add_skins()
##        self.app.find_and_load_installed_pigments()
##        
##        # refresh repo
##        if (npti > 0) | (nptu > 0):
##            import loadrepo
##            gobject.idle_add(lambda:loadrepo.load_repo(self.app, forceReload = True))
##        
##        self.app.runningManagePigments -= 1
##        gobject.idle_add(lambda:self.app.btInstallPigments.set_sensitive(True))
##        
##        
##    def download_pigments(self):
##        """downloads the pigments in self.installDict and moves them to
##        myCacheHome/pigments/pigmentType/pigmentName.tar.gz"""
##        
##        gobject.idle_add(lambda:self.operationsSummary.set_text("Downloading pigments to install"))
##        gobject.idle_add(lambda:self.operationsInformation.set_text("The pigments you selected are being downloaded from the repository"))
##        
##        # prepare list of urls and prepare directories in myCacheHome
##        self.urls = []
##        for pt in self.installDict:
##            for pk in self.installDict[pt]:
##                self.urls.append(self.app.repoURL + get_dirname(pt) + "/" + pk + "/" + pk + ".tar.gz")
##        subprocess.call(["mkdir", "-p", os.path.join(self.app.myCacheHome,"pigments",get_dirname(pt))])
##        
##        # download the urls one by one
##        for url in self.urls:
##            gtk.gdk.threads_enter()
##            self.progressbar.set_text("Downloading " + url.split("/")[-1:][0])
##            self.progressbar.set_fraction(0)
##            gtk.gdk.threads_leave()
##            conn = httplib.HTTPConnection(urlparse.urlparse(url)[1])
##            conn.request("GET",urlparse.urlparse(url)[2])
##            try:
##                r = conn.getresponse()
##            except IOError:
##                print >> sys.stderr, "error ueoqj"
##                return
##            except socket.timeout, ee:
##                print >> sys.stderr, "timeout k"
##                return
##            else:
##                if r.status in [200,301,302]:
##                    conn.close()
##                else:
##                    print >> sys.stderr, "ERR"
##                    break
##                def download_hook(blocksDownloaded,blockSize,size):
##                    frac = blocksDownloaded * blockSize / size
##                    if frac > 1:
##                        frac = 1
##                    gtk.gdk.threads_enter()
##                    self.progressbar.set_fraction(frac)
##                    #progressbar.set_text(url.split("/")[-1:][0])
##                    gtk.gdk.threads_leave()
##                filename, headers = urllib.urlretrieve(url, reporthook=download_hook)
##                # move downloaded file to myCacheHome/pigments/pigmentType/pigmentName.tar.gz
##                subprocess.call(["mkdir", "-p", os.path.join(self.app.myCacheHome, "pigments", url.split("/")[-3:-2][0])])
##                subprocess.call(["mv", "-f",filename, \
##                  os.path.join(self.app.myCacheHome,"pigments",url.split("/")[-3:-2][0],url.split("/")[-1:][0])])
##        
##        gobject.idle_add(lambda:self.operationsInformation.set_text("Downloading finished"))
##
##        
##    def install_pigments(self):
##        """installs pigments in self.installDict by running managepigments.py 
##        as root with gksu"""
##        
##        gobject.idle_add(lambda:self.operationsSummary.set_text("Installing pigments"))
##        gobject.idle_add(lambda:self.operationsInformation.set_text("The pigments you selected are being installed"))
##        
##        
##        # turn self.installDict into a command-line argument list
##        args = []
##        for pt in self.app.pigmentTypes:
##            if len(self.installDict[pt]) > 0:
##                args.append("--%s=" % pt.lower())
##                for pp in self.installDict[pt]:
##                    args[-1] += pp + " "
##                args[-1] = args[-1][:-1] # remove space at the end
##        
##        # TODO: use optparse instead of getopt
##        
##        # get username
##        sIn, sOut,sErr = os.popen3("whoami")
##        username = sOut.read().replace("\n","")
##        
##        manageCommand = ["gksu", "-D", "Epidermis", "--", "python"]        
##        if os.path.exists(os.path.join(determine_path(), "managepigments.py")):
##            manageCommand.append(os.path.join(determine_path(), "managepigments.py"))
##        else:
##            manageCommand.append("/usr/share/epidermis/managepigments.py")        
##        manageCommand.append("--install")
##        manageCommand.extend(args)
##        manageCommand.extend(["--mycachehome=%s" % self.app.myCacheHome, \
##            "--mydatahome=%s" % self.myDataHome, "--user=%s" % username])
##        
##        # call managepigments.py as root using gksu
##        print manageCommand
##        subprocess.call(manageCommand)
##        
##        gobject.idle_add(lambda:self.operationsInformation.set_text("Installing pigments done"))
##
##    
##    def remove_pigments(self):
##        """uninstalls pigments found in self.removeDict by running managepigments.py
##        as root with gksu"""
##
##        gobject.idle_add(lambda:self.operationsSummary.set_text("Uninstalling pigments"))
##        gobject.idle_add(lambda:self.operationsInformation.set_text("The pigments you selected are being removed"))
##
##        # turn removeDict into a command-line arguments list
##        args = []
##        for pt in self.app.pigmentTypes:
##            if len(self.removeDict[pt]) > 0:
##                args.append("--%s=" % pt.lower())
##                for pp in self.removeDict[pt]:
##                    args[-1] += pp + " "
##                args[-1] = args[-1][:-1] # remove trailing space
##        
##        # TODO: use optparse instead of getopt
##        
##        # get username
##        sIn, sOut,sErr = os.popen3("whoami")
##        username = sOut.read().replace("\n","")
##        
##        manageCommand = ["gksu", "-D", "Epidermis", "--", "python"]        
##        if os.path.exists(os.path.join(determine_path(), "managepigments.py")):
##            manageCommand.append(os.path.join(determine_path(), "managepigments.py"))
##        else:
##            manageCommand.append("/usr/share/epidermis/managepigments.py")        
##        manageCommand.append("--remove")
##        manageCommand.extend(args)
##        manageCommand.extend(["--mycachehome=%s" % self.app.myCacheHome, \
##            "--mydatahome=%s" % self.myDataHome, "--user=%s" % username])
##        
##        # call managepigments.py as root using gksu
##        print manageCommand
##        subprocess.call(manageCommand)
##        
##        gobject.idle_add(lambda:self.operationsInformation.set_text("Uninstallation finished"))
##
###---Saving:---#000000#FFFFFF----------------------------------------------------
##
##def save_skin(skin, informationDict, myDataHome):
##    
##    save_pigment(skin, "skin", informationDict, None, myDataHome)
##    return
##
##
##def save_pigment(pigment, pigmentType, informationDict, previewFile, myDataHome, themeFile=None):
##    
##    pigmentTypes = ["skin","wallpaper","metacity","gtk","icons","gnomeSplash","cursors","grub","gdm","usplash"]
##    if not pigmentType in pigmentTypes:
##        print >> sys.stderr, "save_pigment: unrecognised pigmentType: %s" % pigmentType
##        raise()
##        
##    from xml.dom import minidom
##    doc = minidom.Document()
##    root = doc.createElement(pigmentType)
##    doc.appendChild(root)
##    
##    for bit in ("name", "pigment", "description", "copyright", "author"):
##        xmlBit = doc.createElement(bit)
##        tn = doc.createTextNode(informationDict[bit])
##        xmlBit.appendChild(tn)
##        root.appendChild(xmlBit)
##    
##    if pigmentType == "skin":
##        # skin specific stuff
##        if informationDict.has_key("preview"):
##            # xml preview is optional
##            xmlBit = doc.createElement("preview")
##            tn = doc.createTextNode(informationDict["preview"])
##            xmlBit.appendChild(tn)
##            root.appendChild(xmlBit)
##        for bit, sing, brit in (("primaryColors","color", "primarycolours"), ("secondaryColors",\
##        "color","secondarycolours"), ("keyWords", "keyWord", "keywords")):
##            xmlBit = doc.createElement(bit)
##            ss = informationDict[brit].split(",")
##            for word in ss:
##                xmlWord = doc.createElement(sing)
##                tn = doc.createTextNode(word.strip())
##                xmlWord.appendChild(tn)
##                xmlBit.appendChild(xmlWord)
##            root.appendChild(xmlBit)
##        for bit in ("version","webpage"):
##            xmlBit = doc.createElement(bit)
##            xmlBit.appendChild(doc.createTextNode(informationDict[bit]))
##            root.appendChild(xmlBit)
##        for bit in ("wallpaper", "metacity", "gtk", "icons", "gnomeSplash", "cursors", \
##        "grub", "gdm", "usplash"):
##            xmlBit = doc.createElement(bit)
##            xmlPigment = doc.createElement("pigment")
##            xmlPigment.appendChild(doc.createTextNode(informationDict[bit]))
##            xmlBit.appendChild(xmlPigment)
##            xmlName = doc.createElement("name")
##            xmlName.appendChild(doc.createTextNode(read_text_from_pigment( \
##                informationDict[bit], bit, myDataHome, "name")))
##            xmlBit.appendChild(xmlName)
##            root.appendChild(xmlBit)
##    elif pigmentType == "wallpaper":
##        # wallpaper specific stuff
##        for bit in ("pictureOptions", "colorShadingType", "primaryColor"):
##            xmlBit = doc.createElement(bit)
##            tn = doc.createTextNode(informationDict[bit])
##            xmlBit.appendChild(tn)
##            root.appendChild(xmlBit)
##        if informationDict.has_key("secondaryColor"):
##            xmlBit = doc.createElement("secondaryColor")
##            tn = doc.createTextNode(informationDict["secondaryColor"])
##            xmlBit.appendChild(tn)
##            root.appendChild(xmlBit)
##    
##    if pigmentType != "skin":
##        # non skins
##        # xml preview is not optional
##        xmlBit = doc.createElement("preview")
##        tn = doc.createTextNode(informationDict["preview"].split("/")[-1])
##        xmlBit.appendChild(tn)
##        root.appendChild(xmlBit)
##    
##    # handle preview files
##    subprocess.call(["mkdir", "-p", os.path.join(myDataHome, get_dirname(pigmentType), \
##        informationDict["pigment"], "data/")])
##    if informationDict.has_key("preview") and not previewFile is None:
##        if not os.path.exists(previewFile):
##            print >> sys.stderr, "Preview file not found: %s" % previewFile
##            raise("File not found")
##        if os.path.isdir(previewFile):
##            shutil.copytree(previewFile, os.path.join(myDataHome, \
##                get_dirname(pigmentType), informationDict["pigment"]))
##        else:
##            shutil.copy(previewFile, os.path.join(myDataHome, \
##                get_dirname(pigmentType), informationDict["pigment"]))
##                
##    # handle theme file
##    if not themeFile is None:
##        if not os.path.exists(themeFile):
##            print >> sys.stderr, "Theme file not found: %s" % themeFile
##            raise("File not found")
##        if os.path.isdir(themeFile): # directory
##            subprocess.call(["cp", "-r", themeFile, os.path.join(myDataHome, \
##                get_dirname(pigmentType), informationDict["pigment"], "data")])
##        elif themeFile[-7:] == ".tar.gz": # compressed archive
##            justFile = themeFile.split("/")[-1]
##            subprocess.call(["mkdir", "-p", "/tmp/epidermis/installer/" + justFile[-7:]])
##            subprocess.call("cp", themeFile, "/tmp/epidermis/installer/" + justFile[-7:])
##            subprocess.call(["gunzip", justFile], cwd="/tmp/epidermis/installer/%s" % justFile[-7:])
##            subprocess.call(["tar", "-xvvf", justFile[0:-3]] , stdout=os.tmpfile(), cwd="/tmp/epidermis/installer/%s" % justFile[-7:])
##            subprocess.call(handy.join_lists(["cp", "-r"], glob("/tmp/epidermis/installer/%s/*" % justFile[-7:]), \
##                [os.path.join(myDataHome, get_dirname(pigmentType), informationDict["pigment"], "data")]))
##            subprocess.call(["rm", "-r", os.path.join("/tmp/epidermis/installer/", justFile[-7:])])
##        else: # normal file
##            justFile = themeFile.split("/")[-1]
##            subprocess.call(["cp", themeFile, os.path.join(myDataHome, \
##                get_dirname(pigmentType), informationDict["pigment"], "data")])
##    
##    
##    if pigmentType != "skin":
##        if pigmentType in ("wallpaper","gnomeSplash","grub","usplash"):
##            # filename
##            fileOrDir = "filename"
##        else:
##            fileOrDir = "dirname"
##        xmlBit = doc.createElement(fileOrDir)
##        tn = doc.createTextNode(informationDict[fileOrDir].split("/")[-1])
##        xmlBit.appendChild(tn)
##        root.appendChild(xmlBit)
##
##    text = doc.toxml()
##    
##    pigmentDir = os.path.join(myDataHome, get_dirname(pigmentType), informationDict["pigment"])
##    pigmentFile = os.path.join(pigmentDir, pigmentType + ".xml")    
##    
##    if not os.path.exists(pigmentFile):
##        subprocess.call(["touch", pigmentFile])
##        fh = open(pigmentFile, "w")
##        fh.write(text)
##        fh.close()
##    else:
##        print >> sys.stderr, "file already exists: %s" % pigmentFile
##        raise(Exception("file already exists"))
##
##    
##    
##
###---Reading:---#000000#FFFFFF---------------------------------------------------
##
##def read_pigment_xml(pigmentName, pigmentType, myDataHome):
##    """Returns xml object of the pigment's information"""
##    filename = os.path.join(myDataHome, get_dirname(pigmentType), \
##        pigmentName, pigmentType + ".xml")
##    if not os.path.exists(filename):
##        filename = os.path.join(PUBLIC_PIGMENT_DIR, get_dirname(pigmentType), pigmentName, pigmentType + ".xml")
##        if not os.path.exists(filename):
##            print >> sys.stderr, "pigmentName: %s, pigmentType: %s, myDataHome: %s" % (pigmentName, pigmentType, myDataHome)
##            raise PigmentFileNotFoundError(pigmentName, pigmentType, myDataHome)
##    try:
##        thexml = load_xml(filename)
##    except xml.parsers.expat.ExpatError, ee:
##        raise InvalidPigmentXmlError(pigmentName, pigmentType, ee, myDataHome)
##    else:
##        return thexml
##    
##
##def read_from_pigment(pigmentName, pigmentType, myDataHome, element, subelement=None):
##    """Returns the xml object of the element or subelement of the pigment specified"""
##    thexml = read_pigment_xml(pigmentName, pigmentType, myDataHome)
##    if not len(thexml.getElementsByTagName(pigmentType)) > 0:
##        raise IncorrectPigmentXmlError(pigmentName,pigmentType,"no %s element" % pigmentType,myDataHome)
##    return read_from_xml(thexml.getElementsByTagName(pigmentType)[0], pigmentName,pigmentType,element, subelement)
##
##def read_from_xml(thexml, pigmentName, pigmentType, element, subelement=None, myDataHome=None):
##    """Returns the xml object of the element or subelement of xml provided"""
##    try:
##        xml1 = thexml.getElementsByTagName(element)[0]
##    except IndexError, ee:
##        raise IncorrectPigmentXmlError(pigmentName,pigmentType,"no %s element" % element, myDataHome)
##    if not subelement is None:
##        try:
##            return xml1.getElementsByTagName(subelement)[0]
##        except IndexError, ee:
##            raise IncorrectPigmentXmlError(pigmentName,pigmentType,"no %s subelement for %s element" % (subelement,element), myDataHome)            
##    else:
##        return xml1
##
##def read_text_from_pigment(pigmentName,pigmentType,myDataHome,element,subelement=None):
##    """Returns the text from the first text node of the element or subelement of the pigment specified"""
##    thexml = read_from_pigment(pigmentName,pigmentType,myDataHome,element,subelement)
##    try:
##        return get_first_text(thexml)
##    except NoFirstTextError:
##        raise IncorrectPigmentXmlError(pigmentName,pigmentType, "no text node for %s element" % element, myDataHome)
##
##
##def read_text_from_xml(thexml,pigmentName, pigmentType, element,subelement=None,myDataHome=None):
##    """Returns the text from the first text node of the element or subelement of the thexml"""
##    xml1 = read_from_xml(thexml,pigmentName, pigmentType,element,subelement)
##    try:
##        return get_first_text(xml1)
##    except NoFirstTextError:
##        raise IncorrectPigmentXmlError(pigmentName,pigmentType, "no text node for %s element" % element, myDataHome)
##    
##    
##class ReadPigmentError(Exception):
##    def __init__(self, pigmentName, pigmentType, myDataHome=None):
##        self.pigmentName = pigmentName
##        self.pigmentType = pigmentType
##        self.myDataHome = myDataHome
##
##class PigmentFileNotFoundError(ReadPigmentError):
##    def __init__(self, pigmentName, pigmentType, myDataHome=None):
##        ReadPigmentError.__init__(self,pigmentName,pigmentType,myDataHome)
##    def __str__(self):
##        return "cannot find the XML for pigment \"%s\" of type \"%s\" in directory \"%s\"" \
##            % (self.pigmentName, self.pigmentType, str(myDataHome))
##
##class InvalidPigmentXmlError(ReadPigmentError):
##    def __init__(self,pigmentName,pigmentType,xmlError, myDataHome=None):
##        ReadPigmentError.__init__(self,pigmentName,pigmentType,myDataHome)
##        self.xmlError = xmlError
##    def __str__(self):
##        return "pigment \"%s\" of type \"%s\" has unparseable XML\n%s" \
##            % (self.pigmentName, self.pigmentType, str(self.xmlError))
##
##class IncorrectPigmentXmlError(ReadPigmentError):
##    def __init__(self,pigmentName,pigmentType,fault=None,myDataHome=None):
##        ReadPigmentError.__init__(self,pigmentName,pigmentType,myDataHome)
##        self.xmlFault = fault
##    def __str__(self):
##        jj = "pigment \"%s\" of type \"%s\"" % (self.pigmentName, self.pigmentType)
##        if not self.xmlFault is None:
##            jj += " fault: %s" % self.xmlFault
##        return jj
##    
##
##def determine_path ():
##    """Borrowed from wxglade.py"""
##    try:
##        root = __file__
##        if os.path.islink (root):
##            root = os.path.realpath (root)
##        return os.path.dirname (os.path.abspath (root))
##    except:
##        print >> sys.stderr, "I'm sorry, but something is wrong."
##        print >> sys.stderr, "There is no __file__ variable. Please contact the author."
##        sys.exit (1)
##
##def print_help():
##    """prints command-line help"""
##    print \
##    """managepigments.py install or removes epidermis pigments
##    These are the required command line options:
##    either --install or --remove
##    --mycachehome=MYCACHEHOME (only required for --install)
##    --mydatahome=MYDATAHOME
##    --username=USERNAME
##    Followed by a list of pigments to install or remove, in this format:
##    --pigmenttype=PIGMENT1\ PIGMENT2
##    Here are a list of pigment types:
##    --skin
##    --wallpaper
##    --metacity
##    --gtk
##    --icons
##    --gnomesplash
##    --cursors
##    --grub
##    --gdm
##    --usplash"""
##
##
##def install_pigments_commandline(installDict, myCacheHome, myDataHome, username):
##    
##    pigmentTypes = ("skin","wallpaper","metacity","gtk","icons","gnomeSplash","cursors","grub","gdm","usplash")
##    # create shared folder
##    for pt in pigmentTypes:
##        subprocess.call(["mkdir", "-p", os.path.join("/usr/share/epidermis/pigments/", get_dirname(pt))])
##    # prepare tmp
##    subprocess.call(["mkdir", "-p", "/tmp/epidermis"])
##    subprocess.call(["rm", "-r", "/tmp/epidermis/"], stderr=os.tmpfile())
##    subprocess.call(["mkdir", "-p", "/tmp/epidermis/installer"])
##    
##    def extract_in_temp(pigmentType, pigmentName):
##        subprocess.call(handy.join_lists(["rm", "-r"], glob("/tmp/epidermis/installer/*")), stderr=os.tmpfile())
##        subprocess.call(["mv", "-f", os.path.join(myCacheHome, "pigments", get_dirname(pigmentType), pigmentName + ".tar.gz"), \
##            "/tmp/epidermis/installer/"])
##        subprocess.call(["gunzip", "%s.tar.gz" % pigmentName], cwd="/tmp/epidermis/installer")
##        subprocess.call(["tar", "-xvvf", "%s.tar" % pigmentName], stdout=os.tmpfile(), cwd="/tmp/epidermis/installer")
##            
##    def install_pigment_for_user(pigmentType, pigmentName):
##        subprocess.call(["mkdir", "-p", os.path.join(myDataHome,get_dirname(pigmentType), pigmentName)])
##        subprocess.call(handy.join_lists(["cp"], glob("/tmp/epidermis/installer/information/*"), [os.path.join(myDataHome,get_dirname(pigmentType), pigmentName)]))
##        if os.path.abspath(myDataHome) != os.path.abspath(PUBLIC_PIGMENT_DIR):
##            subprocess.call(["chown", username, "-R", os.path.join(myDataHome,get_dirname(pigmentType))])
##            subprocess.call(["chgrp", username, "-R", os.path.join(myDataHome,get_dirname(pigmentType))])
##
##    yesNo = ((True, gtk.STOCK_YES), (True, gtk.STOCK_NO))
##    nErrors = 0
##    
##    
##    # TODO: try and show progress in another process
##    
##    # Wallpapers
##    # wallpapers are copied into /usr/share/backgrounds/epidermis/pigmentname/filename
##    for wp in installDict["wallpaper"]:
##        extract_in_temp("wallpaper",wp)
##        install_pigment_for_user("wallpaper",wp)
##        # wallpapers have optional data, install wallpaper if it has data
##        if len(os.listdir("/tmp/epidermis/installer/data/")) > 0:
##            #print "installing %s wallpaper" % wp
##            subprocess.call(["mkdir", "-p", "/usr/share/backgrounds/epidermis/%s" % wp])
##            subprocess.call(handy.join_lists(["cp", "-f"], glob("/tmp/epidermis/installer/data/*"), ["/usr/share/backgrounds/epidermis/%s/" % wp]))
##    
##    # Metacity
##    # /usr/share/themes/
##    for mt in installDict["metacity"]:
##        extract_in_temp("metacity",mt)
##        dir = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd)):
##                if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd,"metacity-1")):
##                    dir = dd
##                    break
##        if dir == "":
##            print >> sys.stderr, "no metacity theme found in downloaded pigment"
##        else:
##            doInstall = True
##            if os.path.isdir(os.path.join("/usr/share/themes",dir,"metacity-1")):
##                rv = handy.message_box("Metacity theme %s already installed, install anyways?" % dir, \
##                  "Epidermis",yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s metacity" % mt
##                subprocess.call(["mkdir", "-p", "/usr/share/themes/%s/" % dir])
##                subprocess.call(["cp", "-r", "/tmp/epidermis/installer/data/%s/metacity-1/" % dir, "/usr/share/themes/%s/metacity-1" % dir])
##                install_pigment_for_user("metacity", mt)
##    
##    # GTK
##    # they go to /usr/share/themes
##    for gk in installDict["gtk"]:
##        extract_in_temp("gtk",gk)
##        dir = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd)):
##                if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd,"gtk-2.0")):
##                    dir = dd
##                    break
##        if dir == "":
##            print >> sys.stderr, "no gtk-2.0 theme found in downloaded pigment"
##        else:
##            doInstall = True
##            if os.path.isdir(os.path.join("/usr/share/themes",dir,"gtk-2.0")):
##                rv = handy.message_box("gtk-2.0 theme %s already installed, install anyways?" % dir, \
##                "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s gtk" % gk
##                subprocess.call(["mkdir", "-p", "/usr/share/themes/%s/" % dir])
##                subprocess.call(["cp", "-r", "/tmp/epidermis/installer/data/%s/gtk-2.0/" % dir,\
##                    "/usr/share/themes/%s/gtk-2.0" % dir])
##                install_pigment_for_user("gtk", gk)
##        
##    # Icons
##    # installs in /usr/share/icons
##    for ic in installDict["icons"]:
##        extract_in_temp("icons",ic)
##        dir = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd)):
##                dir = dd
##                break
##        if dir == "":
##            print >> sys.stderr, "no icons theme found in downloaded pigment"
##        else:
##            doInstall = True
##            if os.path.isdir(os.path.join("/usr/share/icons",dir)):
##                rv = handy.message_box("icon theme %s already installed, install anyways?" % dir, \
##                    "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                print "installing %s icons" % ic
##                subprocess.call(["mkdir", "-p", "/usr/share/icons/%s" % dir])
##                subprocess.call(handy.join_lists(["cp", "-r"], glob("/tmp/epidermis/installer/data/%s/*" % dir), \
##                    ["/usr/share/icons/%s/" % dir]))
##                install_pigment_for_user("icons", ic)
##    
##    # GnomeSplash
##    # installs in /usr/share/pixmaps/splash/pigmentname-filename
##    for gs in installDict["gnomeSplash"]:
##        extract_in_temp("gnomeSplash",gs)
##        install_pigment_for_user("gnomeSplash",gs)
##        subprocess.call(["mkdir", "-p", "/usr/share/pixmaps/splash"])
##        ff = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data"):
##            if not os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd)):
##                ff = dd
##        if ff == "":
##            print >> sys.stder, "not a gnome splash image: %s" % gs
##        else:
##            #print "installing %s gnomeSplash" % gs
##            subprocess.call(["cp", "/tmp/epidermis/installer/data/%s" % ff, \
##                "/usr/share/pixmaps/splash/%s" % (gs + "-" + ff)])
##    
##    # Cursors
##    # installs in /usr/share/icons
##    for cr in installDict["cursors"]:
##        extract_in_temp("cursors", cr)
##        dir = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd, "cursors")):
##                dir = dd
##                break
##        if dir == "":
##            print >> sys.stderr, "no cursor theme found in downloaded pigment"
##        else:
##            doInstall = True
##            if os.path.isdir(os.path.join("/usr/share/icons",dir, "cursors")):
##                rv = handy.message_box("cursor theme %s already installed, install anyways?" % dir,
##                    "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s cursors" % cr
##                subprocess.call(["mkdir", "-p", "/usr/share/icons/%s" % dir])
##                subprocess.call(handy.join_lists(["cp", "-r"], glob("/tmp/epidermis/installer/data/%s/*" % dir),
##                    ["/usr/share/icons/%s/" % dir]))
##                install_pigment_for_user("cursors", cr)
##    
##    # Grub
##    # installs in /boot/grub/splashimages/
##    for gr in installDict["grub"]:
##        extract_in_temp("grub", gr)
##        ff = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data"):
##            if dd[-7:] == ".xpm.gz":
##                ff = dd
##                break
##        if ff == "":
##            print >> sys.stderr, "not valid grub splash: %s" % gr
##        else:
##            subprocess.call(["mkdir", "-p", "/boot/grub/splashimages/"])
##            doInstall = True
##            if os.path.exists("/boot/grub/splashimages/%s" % ff):
##                rv = handy.message_box("grub splash %s already exists, install anyways?" % ff, \
##                "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s grub" % gr
##                subprocess.call(["cp", "/tmp/epidermis/installer/data/%s" % ff,\
##                    "/boot/grub/splashimages"])
##                install_pigment_for_user("grub",gr)
##    
##    # GDM
##    # installs in /usr/share/gdm/themes
##    for gd in installDict["gdm"]:
##        extract_in_temp("gdm", gd)
##        dir = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if os.path.isdir(os.path.join("/tmp/epidermis/installer/data",dd)):
##                dir = dd
##                break
##        if dir == "":
##            print >> sys.stderr, "no gdm theme found in downloaded pigment"
##        else:
##            doInstall = True
##            if os.path.isdir(os.path.join("/usr/share/gdm/themes",dir)):
##                rv = handy.message_box("gdm theme %s already installed, install anyways?" % dir, \
##                "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s gdm" % gd
##                subprocess.call(["cp", "-r", "/tmp/epidermis/installer/data/%s" % dir, \
##                    "/usr/share/gdm/themes/"])
##                install_pigment_for_user("gdm", gd)
##    
##    # Usplash
##    # installs in /usr/lib/usplash
##    # uses update-alternatives
##    hasInstalledUsplash = False
##    for us in installDict["usplash"]:
##        extract_in_temp("usplash", us)
##        ff = ""
##        for dd in os.listdir("/tmp/epidermis/installer/data/"):
##            if dd[-3:] == ".so":
##                ff = dd
##                break
##        if ff == "":
##            print >> sys.stderr, "%s is not valid usplash pigment" % us
##        else:
##            doInstall = True
##            if os.path.exists("/usr/lib/usplash/%s" % ff):
##                rv = handy.message_box("%s usplash already exists, install anyways?" % ff, \
##                "Epidermis", yesNo)
##                if not rv == gtk.STOCK_YES:
##                    doInstall = False
##            if doInstall:
##                #print "installing %s usplash" % us
##                subprocess.call(["cp", "/tmp/epidermis/installer/data/%s" % ff, "/usr/lib/usplash/"])
##                subprocess.call(["update-alternatives", "--install", "/usr/lib/usplash/usplash-artwork.so", \
##                    "usplash-artwork.so", "/usr/lib/usplash/%s" % ff, "10"])
##                install_pigment_for_user("usplash",us)
##                hasInstalledUsplash = True
##    # TODO: verify if this is required
##    ##if hasInstalledUsplash:
##    ##    subprocess.call("update-initramfs -u", shell=True)
##    ##    print "."
##    
##    # epidermis skin
##    for sc in installDict["skin"]:
##        extract_in_temp("skin",sc)
##        thexml = load_xml("/tmp/epidermis/installer/information/skin.xml")
##        doInstall = True
##        for it in ("wallpaper","metacity","gtk","icons","gnomeSplash","cursors","grub","gdm","usplash"):
##            pac = thexml.getElementsByTagName(it)[0].getElementsByTagName("pigment")[0].firstChild.data
##            if not is_pigment_installed_commandline(it, pac, myDataHome):
##                doInstall = False
##                print >> sys.stderr,"skin %s no dependency %s of type %s" % (sc, pac, it)
##                handy.message_box("Skin %s has unmet dependency: %s of type %s, not installing" \
##                    % (sc, pac, it), "Epidermis", ((True, gtk.STOCK_OK),))
##                break
##        if doInstall:
##            install_pigment_for_user("skin",sc)
##    
##    print "done installing pigments"
##    
##
##def remove_pigments_commandline(removeDict, myDataHome, username, myCacheHome=""):
##    
##    
##    def remove_pigment_for_user(pigmentType, pigmentName):
##        subprocess.call(["rm", "-r", os.path.join(myDataHome, get_dirname(pigmentType),pigmentName)])
##        if not os.path.exists(os.path.join(myDataHome, get_dirname(pigmentType), pigmentName)):
##            print >> sys.stderr, "Can't find pigment to delete: pigmentType: %s, pigmentName: %s, myDataHome: %s" % \
##                (pigmentType, pigmentName, myDataHome)
##    
##    
##    # Wallpapers
##    # wallpapers have been copied into /usr/share/backgrounds/epidermis/pigmentname/filename
##    for wp in removeDict["wallpaper"]:
##        remove_pigment_for_user("wallpaper",wp)
##        subprocess.call(["rm", "-r", "/usr/share/backgrounds/epidermis/%s/" % wp])
##    
##    # Metacity
##    # found in /usr/share/themes/
##    for mt in removeDict["metacity"]:
##        thexml = load_xml(os.path.join(myDataHome,"metacity",mt,"metacity.xml"))
##        mtdd = thexml.getElementsByTagName("dirname")[0].firstChild.data
##        subprocess.call(["rm", "-r", "/usr/share/themes/%s/metacity-1" % mtdd])
##        foundDir = False
##        for dd in os.listdir("/usr/share/themes/%s/" % mtdd):
##            if os.path.isdir("/usr/share/themes/%s/%s" % (mtdd, dd)):
##                foundDir = True
##                break
##        if not foundDir:
##            subprocess.call(["rm", "-r", "/usr/share/themes/%s" % mtdd])
##        remove_pigment_for_user("metacity", mt)
##
##    
##    # GTK
##    # found in /usr/share/themes
##    for gk in removeDict["gtk"]:
##        thexml = load_xml(os.path.join(myDataHome,"gtk-2.0",gk,"gtk.xml"))
##        gkdd = thexml.getElementsByTagName("dirname")[0].firstChild.data
##        #print gk, gkdd
##        if os.path.isdir("/usr/share/themes/%s/metacity-1" % gkdd):
##            for dd in os.listdir("/usr/share/themes/%s/" % gkdd):
##                if os.path.isdir("/usr/share/themes/%s/%s" % (gkdd, dd)) and dd != "metacity-1":
##                    subprocess.call(["rm", "-r", "/usr/share/themes/%s/%s" % (gkdd, dd)])
##        else:
##            subprocess.call(["rm", "-r", "/usr/share/themes/%s" % gkdd])
##        remove_pigment_for_user("gtk",gk)
##
##        
##    # Icons
##    # found in /usr/share/icons/
##    for ic in removeDict["icons"]:
##        thexml = load_xml(os.path.join(myDataHome,"icons",ic,"icons.xml"))
##        icdd = thexml.getElementsByTagName("dirname")[0].firstChild.data
##        if os.path.isdir("/usr/share/icons/%s/cursors" % icdd):
##            for dd in os.listdir("/usr/share/icons/%s/" % icdd):
##                if os.path.isdir("/usr/share/icons/%s/%s" % (icdd, dd)) and dd != "cursors":
##                    subprocess.call(["rm", "-r", "/usr/share/icons/%s/%s"])
##        else:
##            subprocess.call(["rm", "-r", "/usr/share/icons/%s" % icdd])
##        remove_pigment_for_user("icons",ic)
##    
##    
##    # GnomeSplash
##    # installs in /usr/share/pixmaps/splash/pigmentname-filename
##    for gs in removeDict["gnomeSplash"]:
##        thexml = load_xml(os.path.join(myDataHome,"gnomeSplashes",gs,"gnomeSplash.xml"))
##        gsff = thexml.getElementsByTagName("filename")[0].firstChild.data
##        subprocess.call(["rm", "/usr/share/pixmaps/splash/%s-%s" % (gs, gsff)])
##        remove_pigment_for_user("gnomeSplash", gs)
##    
##    # Cursors
##    # found in /usr/share/icons/themename/cursors and cursors.theme
##    for cr in removeDict["cursors"]:
##        thexml = load_xml(os.path.join(myDataHome,"cursors",cr,"cursors.xml"))
##        crdd = thexml.getElementsByTagName("dirname")[0].firstChild.data
##        subprocess.call(["rm", "-r", "/usr/share/icons/%s/cursors" % crdd])
##        subprocess.call(["rm", "-f", "/usr/share/icons/%s/cursors.theme" % crdd])
##        foundDir = False
##        for dd in os.listdir("/usr/share/icons/%s/" % crdd):
##            if os.path.isdir("/usr/share/icons/%s/%s" % (crdd, dd)):
##                foundDir = True
##                break
##        if not foundDir:
##            subprocess.call(["rm", "-r", "/usr/share/icons/%s" % crdd])
##        remove_pigment_for_user("cursors", cr)
##    
##    # Grub
##    # found in /boot/grub/splashimages/
##    for gr in removeDict["grub"]:
##        thexml = load_xml(os.path.join(myDataHome,"grub",gr,"grub.xml"))
##        grdd = thexml.getElementsByTagName("filename")[0].firstChild.data
##        subprocess.call(["rm", "/boot/grub/splashimages/%s" % grdd])
##        remove_pigment_for_user("grub",gr)
##        
##    
##    # GDM
##    # found in /usr/share/gdm/themes
##    for gd in removeDict["gdm"]:
##        thexml = load_xml(os.path.join(myDataHome,"gdm",gd,"gdm.xml"))
##        gddd = thexml.getElementsByTagName("dirname")[0].firstChild.data
##        subprocess.call(["rm", "-r", "/usr/share/gdm/themes/%s" % gddd])
##        remove_pigment_for_user("gdm",gd)
##    
##    # Usplash
##    # found in /usr/lib/usplash
##    # uses update-alternatives
##    hasUninstalledUsplash = False
##    for us in removeDict["usplash"]:
##        thexml = load_xml(os.path.join(myDataHome,"usplashes",us, "usplash.xml"))
##        usff = thexml.getElementsByTagName("filename")[0].firstChild.data
##        subprocess.call(["update-alternatives", "--remove", "usplash-artwork.so", "/usr/lib/usplash/%s" % usff])
##        subprocess.call(["rm", "/usr/lib/usplash/%s" % usff])
##        remove_pigment_for_user("usplash",us)
##    # TODO: verify if this is required
##    ##if hasUninstalledUsplash:
##    ##    subprocess.call("update-initramfs -u", shell=True)
##    ##    print "."
##    
##    # epidermis look skin
##    for sc in removeDict["skin"]:
##        remove_pigment_for_user("skin",sc)
##    
##    print "done uninstalling pigments"
##
##def is_pigment_installed_commandline(pigmentType,pigment,myDataHome):
##    if os.path.exists(os.path.join(myDataHome, get_dirname(pigmentType),pigment, pigmentType + ".xml")):
##        return True
##    elif os.path.exists(os.path.join(PUBLIC_PIGMENT_DIR, get_dirname(pigmentType), pigment, pigmentType + ".xml")):
##        return True
##    else:
##        return False
##
##class NoFirstTextError(Exception):
##    def __str__(self):
##        return "NoFirstTextError: XML node does not have a text node"
##
##def get_first_text(thexml):
##    for el in thexml.childNodes:
##        if el.nodeType == xml.dom.Node.TEXT_NODE:
##            return el.data
##    raise(NoFirstTextError())
##
###---Other:---#000000#FFFFFF-----------------------------------------------------
##
##def get_dirname(singular):
##    """Turns nouns into the corresponding directory found in dataHome +
##    \"epidermis/\"
##    Eg: wallpaper into wallpapers, gdm into gdm"""
##    s = singular.lower()
##    if s == "cursors" or s == "gdm" or s == "icons" \
##        or s == "grub" or s == "icons" or s == "metacity":
##        return s
##    elif s == "usplash":
##        return s + "es"
##    elif s == "gnomesplash":
##        return "gnomeSplashes"
##    elif s == "gtk":
##        return "gtk-2.0"
##    else:
##        return s + "s"
##
##def load_xml(filename):
##    """Load an XML file and returns the parsed XML object"""
##    from xml.dom import minidom
##    return minidom.parse(filename)
##
##def main():
##    
##    # called by ManagePigmentsThread.install_pigments or ManagePigmentsThread.remove_pigments
##    
##    # init
##    gtk.gdk.threads_init()
##    pigmentTypes = ["skin","wallpaper","metacity","gtk","icons","gnomeSplash","cursors","grub","gdm","usplash"]
##    opts, args = getopt.getopt(sys.argv[1:],"",["install","remove","mydatahome=","mycachehome=","user=", "skin=","wallpaper=","metacity=","gtk=","icons=","gnomesplash=","cursors=","grub=","gdm=","usplash="])
##    manageDict = {"skin":[],"wallpaper":[],"metacity":[],"gtk":[],"icons":[],"gnomeSplash":[],"cursors":[], "grub":[],"gdm":[],"usplash":[]}
##    
##    doInstall = False
##    doRemove = False
##    myCacheHome = ""
##    myDataHome = ""
##    username = ""
##    
##    # transforms command line arguments into dictionary and various variables
##    for pt, val in opts:
##        vals = val.split(" ")
##        if manageDict.has_key(pt[2:]):
##            for vv in vals:
##                manageDict[pt[2:]].append(vv)
##        elif pt == "--gnomesplash":
##            for vv in vals:
##                manageDict["gnomeSplash"].append(vv)
##        elif pt == "--mycachehome":
##            myCacheHome = val
##        elif pt == "--mydatahome":
##            myDataHome = val
##        elif pt == "--user":
##            username = val
##        elif pt == "--install":
##            doInstall = True
##        elif pt == "--remove":
##            doRemove = True
##    
##    # choose which funciton to pass to:    
##    #print sys.argv[1:]
##    if doInstall and doRemove:
##        print >> sys.stderr, "error: both --install and --remove selected"
##        sys.exit(2)
##    elif doInstall and (myCacheHome != "") and (myDataHome != "") and (username != ""):
##        install_pigments_commandline(manageDict,myCacheHome=myCacheHome,myDataHome=myDataHome,username=username)
##        
##    elif doRemove and (myDataHome != "") and (username != ""):
##        remove_pigments_commandline(manageDict,myCacheHome=myCacheHome,myDataHome=myDataHome,username=username)
##
##    else:
##        if (sys.argv) > 1 or True:
##            print >> sys.stderr, "Invalid command line arguments: \"%s\"" % str(sys.argv[1:])
##        print_help()
##        sys.exit(1)
##        
##
##if __name__ == "__main__":
##    pass
##    main()
